package gov.nlrb.mobile
{
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.filesystem.File;
	import flash.filesystem.FileMode;
	import flash.filesystem.FileStream;
	import flash.net.URLLoader;
	import flash.net.URLLoaderDataFormat;
	import flash.net.URLRequest;
	import flash.utils.ByteArray;
	import flash.utils.Dictionary;
	
	import mx.core.FlexGlobals;
	import mx.rpc.events.FaultEvent;
	import mx.rpc.events.ResultEvent;
	import mx.rpc.http.mxml.HTTPService;
	
	import spark.components.BusyIndicator;
	import spark.components.Button;
	import spark.events.PopUpEvent;
	
	public class DataService
	{
		private static var _content:Singleton = Singleton.getInstance();
		private static var _content_remote:Object =new Object();
		private static var _content_temp:Object =new Object();
		private static var _img_dict:Dictionary=new Dictionary();
		private static var _update_tasks:Dictionary=null;
		private static var _forced_update:Boolean=false;
		
		private static var REMOTE_METADAT_URL:String="[URL to the server data feeder]";
		private static var SILENT_TIME_IN_SECONDS:Number=0; //check data update every time the application starts
		private static var isHttpError:Boolean=false;
		private static var busyIndicator:BusyIndicator;
		private static var btnRefresh:Button;
		
		private static function DisplayHideControls(vi:Boolean):void
		{
			busyIndicator.visible=vi;
			btnRefresh.visible=!vi;
		}
		public static function RefreshData(forced:Boolean=false,bi:BusyIndicator=null,btn:Button=null):void{
			_forced_update=forced;
			
			var file:File  = File.applicationStorageDirectory.resolvePath("Documents/globalContent.json");
			busyIndicator=bi;
			btnRefresh=btn;
			DisplayHideControls(true);
			
			//load embedded version if the main data is not found
			if (!file.exists)
				AppFirstSetup();
			
			try{
				var fileStream:FileStream = new FileStream();
				fileStream.open(file, FileMode.READ);				
				var strContent:String=fileStream.readUTFBytes(fileStream.bytesAvailable);
				fileStream.close();
				
				//read local copy
				_content.maincontent=JSON.parse(strContent) as Object;
				DisplayHideControls(false);
				return;
			}
			catch (e:Error)
			{
				AppFirstSetup();
				var fileStream2:FileStream = new FileStream();
				fileStream2.open(file, FileMode.READ);				
				var strContent2:String=fileStream.readUTFBytes(fileStream.bytesAvailable);
				fileStream2.close();
				
				//read local copy
				_content.maincontent=JSON.parse(strContent2) as Object;
			}
			
			if (!_forced_update)
			{
				var SILENT_PERIOD:Number = SILENT_TIME_IN_SECONDS; 
				
				var _tmpDate:Date=new Date();	
				var _tmpDate_last:Date=new Date(2000,1,1);
				
				if (_content.maincontent.metaData.last_check!=null)
					_tmpDate_last=new Date(_content.maincontent.metaData.last_check);
				else
					_tmpDate_last=new Date(2000,1,1);
				var tempDate:Date = new Date(_tmpDate.time - _tmpDate_last.time);
				if (tempDate.time<SILENT_PERIOD*1000)
				{
					DisplayHideControls(false);
					return;
				}
			}	
			
			
			//read remote copy: metadata
			ClearFolder("tmp");
			_update_tasks=new Dictionary();
			
			var hs_step1:HTTPService=new HTTPService();
			hs_step1.url=REMOTE_METADAT_URL;
			hs_step1.resultFormat = "text";
			//hs_step1.method = URLRequestMethod.GET;
			hs_step1.headers["Pragma"] = "no-cache";  // no caching of the file
			hs_step1.headers["Cache-Control"] = "no-cache";
			
			hs_step1.addEventListener("result",GetRemote_Metadata_Post);
			hs_step1.addEventListener("fault",faultMetadataResult);
			hs_step1.send();	
			
		}
		
		public static function ClearFolder(fd:String):void{
			var fileDirectry:File = File.applicationStorageDirectory.resolvePath(fd);
			
			if (fileDirectry.exists)
			{
				var files:Array = fileDirectry.getDirectoryListing();
				for each(var file:File in files)
				{
					file.deleteFile();
				}	
			}
		}
		
		private function onCloseAlert(event:PopUpEvent):void
		{
			// Do some stuff here   
		} 
		
		protected static function GetRemote_Metadata_Post(evt:ResultEvent):void{     
			try{
				var objRemote:Object=JSON.parse(evt.result.toString()) as Object;
				_content_remote=clone(_content.maincontent);
				_content_remote.metaData=objRemote;
				
				
				//major version
				if (_content_remote.metaData.app_version_major!=_content.maincontent.metaData.app_version_major)
				{
					FlexGlobals.topLevelApplication.DisplayWarning();
					return;
				}
				
				_update_tasks["RO"]=1;  //regional offices
				_update_tasks["LT"]=1;	//label text
				_update_tasks["KR"]=1;  //know your rights
				_update_tasks["RA"]=1;	//Related Agencies
				_update_tasks["IM"]=1;	//slides
				
				var _update:Boolean=false;
				
				//regional officer version
				if (_forced_update || _content_remote.metaData.content.offices.lastmod!=_content.maincontent.metaData.content.offices.lastmod)
				{
					var hs_ro:HTTPService=new HTTPService();
					hs_ro.url=_content_remote.metaData.content.offices.url;
					hs_ro.resultFormat = "text";
					//hs_ro.method = URLRequestMethod.GET;
					hs_ro.headers["Pragma"] = "no-cache";  // no caching of the file
					hs_ro.headers["Cache-Control"] = "no-cache";
					hs_ro.addEventListener("result",RegionalOffice_Post);
					hs_ro.addEventListener("fault",RegionalOffice_Fault);
					hs_ro.send();
					_update=true;
				}
				else
					delete _update_tasks["RO"];
				
				//label text version
				if (_forced_update || _content_remote.metaData.content.label_text.lastmod!=_content.maincontent.metaData.content.label_text.lastmod)
				{
					var hs_lt:HTTPService=new HTTPService();
					hs_lt.url=_content_remote.metaData.content.label_text.url;
					hs_lt.resultFormat = "text";
					//hs_lt.method = URLRequestMethod.GET;
					hs_lt.headers["Pragma"] = "no-cache";  // no caching of the file
					hs_lt.headers["Cache-Control"] = "no-cache";
					
					
					hs_lt.addEventListener("result",LabelText_Post);
					hs_lt.addEventListener("fault",LabelText_Fault);
					hs_lt.send();
					_update=true;
				}
				else
					delete _update_tasks["LT"];
				
				//know your rights
				if (_forced_update || _content_remote.metaData.content["know-your-rights"].lastmod!=_content.maincontent.metaData.content["know-your-rights"].lastmod)
				{
					var hs_kr:HTTPService=new HTTPService();
					hs_kr.url=_content_remote.metaData.content["know-your-rights"].url;
					hs_kr.resultFormat = "text";
					hs_kr.headers["Pragma"] = "no-cache";  // no caching of the file
					hs_kr.headers["Cache-Control"] = "no-cache";
					
					
					hs_kr.addEventListener("result",Know_your_rights_Post);
					hs_kr.addEventListener("fault",Know_your_rights_Fault);
					hs_kr.send();
					_update=true;
				}
				else
					delete _update_tasks["KR"];
				
				//related agencies
				if (_forced_update || _content_remote.metaData.content["related-agencies"].lastmod!=_content.maincontent.metaData.content["related-agencies"].lastmod)
				{
					var hs_ra:HTTPService=new HTTPService();
					hs_ra.url=_content_remote.metaData.content["related-agencies"].url;
					hs_ra.resultFormat = "text";
					hs_ra.headers["Pragma"] = "no-cache";  // no caching of the file
					hs_ra.headers["Cache-Control"] = "no-cache";
					
					hs_ra.addEventListener("result",RelatedAgencies_Post);
					hs_ra.addEventListener("fault",RelatedAgencies_Fault);
					hs_ra.send();
					_update=true;
				}
				else
					delete _update_tasks["RA"];
				
				//slides
				if (_forced_update || _content_remote.metaData.content.slideshow.lastmod!=_content.maincontent.metaData.content.slideshow.lastmod)
				{
					var hs_im:HTTPService=new HTTPService();
					
					hs_im.url=_content_remote.metaData.content.slideshow.url;
					hs_im.resultFormat = "text";
					hs_im.headers["Pragma"] = "no-cache";  // no caching of the file
					hs_im.headers["Cache-Control"] = "no-cache";
					
					hs_im.addEventListener("result",Slides_Post);
					hs_im.addEventListener("fault",Slides_Fault);
					hs_im.send();
					_update=true;
				}
				else
					delete _update_tasks["IM"];
				
				_content.maincontent.metaData.last_check=new Date();
				
				if (!_update)
					DisplayHideControls(false);
				
			}
			catch(e:Error)
			{
				
			}
		}
		
		protected static function RegionalOffice_Post(evt:ResultEvent):void{
			try{
				var objRemote:Object=JSON.parse(evt.result.toString()) as Object;
				_content_remote.regionOffices=objRemote;
				_content.maincontent.metaData.content.offices.lastmod=_content_remote.metaData.content.offices.lastmod;
				
				
			}
			catch(e:Error)
			{
				
			}
			finally
			{
				delete _update_tasks["RO"];
				CommitTempContent();				
			}
		}
		
		protected static function RegionalOffice_Fault(e:Event):void{              
			delete _update_tasks["RO"];
			isHttpError=true;
			CommitTempContent();
		} 
		
		protected static function LabelText_Post(evt:ResultEvent):void{
			try{
				var objRemote:Object=JSON.parse(evt.result.toString()) as Object;
				_content_remote.textualContent=objRemote;
				_content.maincontent.metaData.content.label_text.lastmod=_content_remote.metaData.content.label_text.lastmod;
			}
			catch(e:Error)
			{
				
			}
			finally
			{
				delete _update_tasks["LT"];
				CommitTempContent();
			}
		}
		
		protected static function LabelText_Fault(e:Event):void{              
			delete _update_tasks["LT"];
			isHttpError=true;
			CommitTempContent();
		}
		
		protected static function Know_your_rights_Post(evt:ResultEvent):void{
			try{
				var objRemote:Object=JSON.parse(evt.result.toString()) as Object;
				_content_remote.know_your_rights=objRemote;
				_content.maincontent.metaData.content["know-your-rights"].lastmod=_content_remote.metaData.content["know-your-rights"].lastmod;
			}
			catch(e:Error)
			{
				
			}
			finally
			{
				delete _update_tasks["KR"];
				CommitTempContent();
			}
		}
		
		protected static function Know_your_rights_Fault(e:Event):void{              
			delete _update_tasks["KR"];
			isHttpError=true;
			CommitTempContent();
		}
		
		protected static function RelatedAgencies_Post(evt:ResultEvent):void{
			try{
				var objRemote:Object=JSON.parse(evt.result.toString()) as Object;
				_content_remote.textualContent.relatedAgencies=objRemote.body;
				_content.maincontent.metaData.content["related-agencies"].lastmod=_content_remote.metaData.content["related-agencies"].lastmod;
			}
			catch(e:Error)
			{
				
			}
			finally
			{
				delete _update_tasks["RA"];
				CommitTempContent();
			}
		}
		
		protected static function RelatedAgencies_Fault(e:Event):void{              
			delete _update_tasks["RA"];
			isHttpError=true;
			CommitTempContent();
		}
		
		protected static function Slides_Post(evt:ResultEvent):void{
			var objRemote:Object=JSON.parse(evt.result.toString()) as Object;
			_content_remote.slides=objRemote;
			
			_content.maincontent.metaData.content.slideshow.lastmod=_content_remote.metaData.content.slideshow.lastmod;
			
			var _rdn:Date=new Date();
			var count:int=0;
			
			for(var i:Number=0;i<objRemote.length;i++)
			{
				if ( _content.maincontent.slides[i].lastmod!=_content_remote.slides[i].lastmod)
				{
					var fn:Number=i+1;
					
					var _loader:URLLoader=new URLLoader();
					_loader.dataFormat= URLLoaderDataFormat.BINARY;
					var requester :URLRequest = new URLRequest(objRemote[i].url+ "?bogus=" + _rdn.getTime().toString());
					_loader.addEventListener(Event.COMPLETE, Slides_Post_Images);
					_loader.addEventListener(IOErrorEvent.IO_ERROR, Slides_Images_Fault);
					
					_loader.load(requester);
					_img_dict[_loader]=fn;
					count++;
				}
				
			}
			
			
			if (count==0)
			{
				delete _update_tasks["IM"];
				CommitTempContent();
			}
		}
		
		protected static function Slides_Post_Images(evt:Event):void{
			var _cloader:URLLoader=evt.currentTarget as URLLoader;
			
			if (_cloader.bytesLoaded<1024)
			{
				Slides_Images_Fault(evt);
				return;
			}
			
			var fn:Number=_img_dict[_cloader];
			
			var file_local:File = File.applicationStorageDirectory.resolvePath("tmp/img_" + fn.toString() + ".jpg");
			var fileStream_local:FileStream = new FileStream();
			fileStream_local.open(file_local, FileMode.WRITE);				
			
			fileStream_local.writeBytes(_cloader.data, 0, _cloader.bytesLoaded);				
			fileStream_local.close();
			
			delete _img_dict[_cloader];
			
			//no more error, commit Temp folder
			var count:int = 0;
			
			for (var key:Object in _img_dict)
			{
				count++;
			}
			
			//save the content
			if (count==0)
			{
				delete _update_tasks["IM"];
				CommitTempContent();
			}
		}
		
		protected static function Slides_Fault(e:Event):void{              
			delete _update_tasks["IM"];
			isHttpError=true;
			CommitTempContent();
		}
		
		protected static function Slides_Images_Fault(e:Event):void{              
			delete _update_tasks["IM"];
			isHttpError=true;
			CommitTempContent();
		}
		
		public static function SaveContent():void{
			var file_local:File  = File.applicationStorageDirectory.resolvePath("Documents/globalContent.json");	
			var ct:String  = JSON.stringify(_content.maincontent);
			
			var fileStream_local:FileStream = new FileStream();
			fileStream_local.open(file_local, FileMode.WRITE);				
			var oByteArray:ByteArray = new ByteArray();
			
			oByteArray.writeUTFBytes(ct);
			fileStream_local.writeBytes(oByteArray, 0, oByteArray.length);				
			fileStream_local.close();
		}
		
		private static function CommitTempContent():void{
			
			var count:int = 0;
			
			for (var key:Object in _update_tasks)
			{
				count++;
			}
			
			if (count>0)
				return;
			
			if (isHttpError)
			{
				ClearFolder("tmp");
				DisplayHideControls(false);
				return;
			}
				
			
			var fileDirectry:File = File.applicationStorageDirectory.resolvePath("tmp");
			
			var files:Array = fileDirectry.getDirectoryListing();
			for each(var file:File in files)
			{
				var _dest_file:File=File.applicationStorageDirectory.resolvePath("Documents/" + file.name);
				file.copyTo(_dest_file,true);
			}	
			
			_content.maincontent=clone(_content_remote);
			_content.maincontent.metaData.last_check=new Date();
		
			
			var file_local:File  = File.applicationStorageDirectory.resolvePath("Documents/globalContent.json");	
			var ct:String  = JSON.stringify(_content.maincontent);
			
			var fileStream_local:FileStream = new FileStream();
			fileStream_local.open(file_local, FileMode.WRITE);				
			var oByteArray:ByteArray = new ByteArray();
			
			oByteArray.writeUTFBytes(ct);
			fileStream_local.writeBytes(oByteArray, 0, oByteArray.length);				
			fileStream_local.close();
			
			ClearFolder("tmp");
			
			DisplayHideControls(false);
				
		}	
		
		
		/***********Below is used to get a sample global content json file ****/
		
		
		
		/***********end of get a sample global content json file ****/
		
		
		
		/******Only execute once when the app is first loaded ****************/
		private static function AppFirstSetup():void{
			var fileDirectry2:File = File.applicationStorageDirectory.resolvePath("Documents");
			if (!fileDirectry2.exists)
			{
				fileDirectry2.createDirectory();
			}
			
			//temp folder for transaction
			var fileDirectry:File = File.applicationStorageDirectory.resolvePath("tmp");
			if (!fileDirectry.exists)
			{
				fileDirectry.createDirectory();
			}
			
			CopyInitialFiles("Documents");
		}
		
		private static function CopyInitialFiles(targetFolder:String):void{
			var fileDirectry:File = new File("app:/LatestContent");
			
			var files:Array = fileDirectry.getDirectoryListing();
			for each(var file:File in files)
			{
				var _dest_file:File=File.applicationStorageDirectory.resolvePath(targetFolder + "/" + file.name);
				file.copyTo(_dest_file,true);
			}	
			
			
		}
		
		protected static function getMetadataResult(evt:ResultEvent):void{              
			
		}
		
		
		protected static function faultMetadataResult(e:FaultEvent):void{              
			DisplayHideControls(false);
		} 
		
		public static function SaveData():void{
			_content.sessiondata=null;
			
			var file:File  = File.applicationStorageDirectory.resolvePath("Documents/globalContent.json");	
			var ct:String  = JSON.stringify(_content);
			
			var fileStream_local:FileStream = new FileStream();
			fileStream_local.open(file, FileMode.WRITE);				
			var oByteArray:ByteArray = new ByteArray();
			
			oByteArray.writeUTFBytes(ct);
			fileStream_local.writeBytes(oByteArray, 0, oByteArray.length);				
			fileStream_local.close();
		}
		
		private static function clone(source:Object):*{
			var byteArray:ByteArray = new ByteArray();
			byteArray.writeObject(source);
			byteArray.position = 0;
			return(byteArray.readObject());
		}
	}
}