package gov.nlrb.mobile
{
	import flash.events.MouseEvent;
	import flash.system.Capabilities;
	//import flash.text.StyleSheet;
	
	import spark.components.Label;
	import spark.components.LabelItemRenderer;
	import spark.components.TextArea;
	import spark.components.supportClasses.StyleableTextField;
	import spark.skins.mobile.TextAreaSkin;

	
	
	/**
	 * 
	 * ASDoc comments for this item renderer class
	 * 
	 */
	public class KnowRightsAnswerDetailsItemRenderer extends LabelItemRenderer
	{
		public var lblAnswer:TextArea;
		public var btnMoreOrLess:Label;
		
		
		public function KnowRightsAnswerDetailsItemRenderer()
		{
			//TODO: implement function
			super();
		}
		
		/**
		 * @private
		 *
		 * Override this setter to respond to data changes
		 */
		override public function set data(value:Object):void
		{
			super.data = value;
			labelDisplay.lineBreak="toFit";
			labelDisplay.htmlText=data.title;
			StyleableTextField(lblAnswer.textDisplay).htmlText=data.summary; 
			
		} 
		
		/**
		 * @private
		 * 
		 * Override this method to create children for your item renderer 
		 */	
		override protected function createChildren():void
		{
			super.createChildren();
			// create any additional children for your item renderer here
			
			
			
			lblAnswer=new TextArea();
			lblAnswer.setStyle('skinClass', spark.skins.mobile.TextAreaSkin);
			lblAnswer.setStyle("contentBackgroundColor","#ffffff");
			lblAnswer.setStyle("borderVisible","false");
			lblAnswer.heightInLines=NaN;
			lblAnswer.editable=false;
			lblAnswer.setStyle("verticalScrollPolicy","off");
			lblAnswer.styleName="answermore";
			
			
			btnMoreOrLess=new Label();
			btnMoreOrLess.text="Learn more";	
			btnMoreOrLess.styleName="breadscrumb_link";
			btnMoreOrLess.setStyle("fontSize",28);
			btnMoreOrLess.width=screen.width/2;
			btnMoreOrLess.height=50;
			
			addChild(lblAnswer);
			addChild(btnMoreOrLess);
			
			btnMoreOrLess.addEventListener("click", MoreorLess);
		}
		
		private function MoreorLess(evt:MouseEvent):void{
			parentDocument.parentDocument.getMore(data);
		}
		
		/**
		 * @private
		 * 
		 * Override this method to change how the item renderer 
		 * sizes itself. For performance reasons, do not call 
		 * super.measure() unless you need to.
		 */ 
		override protected function measure():void
		{
			super.measure();
			
			
			var lPadding:Number = getStyle("paddingLeft");
			var rPadding:Number = getStyle("paddingRight");
			var tPadding:Number = getStyle("paddingTop");
			var bPadding:Number = getStyle("paddingBottom");
			
			labelDisplay.width=screen.width-30; 
			
			
			var _os:String=Capabilities.os;
			if (_os.indexOf("iPhone")>=0)
				lblAnswer.width=  screen.width-30;
			else
				lblAnswer.width=  screen.width-30; 
			lblAnswer.validateNow();
			lblAnswer.height= getElementPreferredHeight(lblAnswer);
			
			
			
			measuredHeight=getElementPreferredHeight(labelDisplay);
			measuredHeight += getElementPreferredHeight(lblAnswer);
			measuredHeight += getElementPreferredHeight(btnMoreOrLess);
			measuredHeight += tPadding+bPadding+10;
			
			
		}
		
		/**
		 * @private
		 * 
		 * Override this method to change how the background is drawn for 
		 * item renderer.  For performance reasons, do not call 
		 * super.drawBackground() if you do not need to.
		 */
		override protected function drawBackground(unscaledWidth:Number, 
												   unscaledHeight:Number):void
		{
			//super.drawBackground(unscaledWidth, unscaledHeight);
			// do any drawing for the background of the item renderer here  
			var bgColor:uint = 0xffffff;
			
			graphics.clear();
			
			graphics.beginFill(bgColor,1);
			graphics.lineStyle();
			graphics.drawRect(0, 0, unscaledWidth, unscaledHeight);
			graphics.endFill();
			
			// Draw the separator for the item renderer
			super.drawBorder(unscaledWidth, unscaledHeight);
			
			opaqueBackground = bgColor;
		}
		
		/**
		 * @private
		 *  
		 * Override this method to change how the background is drawn for this 
		 * item renderer. For performance reasons, do not call 
		 * super.layoutContents() if you do not need to.
		 */
		override protected function layoutContents(unscaledWidth:Number, 
												   unscaledHeight:Number):void
		{
			super.layoutContents(unscaledWidth, unscaledHeight);
			// layout all the subcomponents here 
			var lPadding:Number = getStyle("paddingLeft");
			var rPadding:Number = getStyle("paddingRight");
			var tPadding:Number = getStyle("paddingTop");
			var bPadding:Number = getStyle("paddingBottom");
			
			
			labelDisplay.y=tPadding;
			lblAnswer.y=labelDisplay.y+labelDisplay.height;
			btnMoreOrLess.y=lblAnswer.y+lblAnswer.height;
			btnMoreOrLess.x=10;
		}
		
	}
}