package gov.nlrb.mobile
{
	import flash.events.MouseEvent;
	import flash.net.URLRequest;
	import flash.net.navigateToURL;
	
	import mx.formatters.PhoneFormatter;
	
	import spark.components.Label;
	import spark.components.LabelItemRenderer;
	
	
	/**
	 * 
	 * ASDoc comments for this item renderer class
	 * 
	 */
	public class RegionalOfficeDetailsItemRenderer extends LabelItemRenderer
	{
		public var lblTitle:Label;
		public var lblBuilding:Label;
		public var lblAddress:Label;
		public var lblPhone1:Label;
		public var lblPhone2:Label;
		public var lblFax:Label;
		public var lblTTY:Label;
		
		private var _line_padding:Number=10;
		
		
		public function RegionalOfficeDetailsItemRenderer()
		{
			//TODO: implement function
			super();
		}
		
		/**
		 * @private
		 *
		 * Override this setter to respond to data changes
		 */
		override public function set data(value:Object):void
		{
			super.data = value;
			// the data has changed.  push these changes down in to the 
			// subcomponents here  
			
			var _office:Object=value.OfficeObject;
			var phoneFormatter:PhoneFormatter = new PhoneFormatter();
			lblTitle.text=_office.region + " - " + _office.address.locality;
			
			var _str:String="";
			if (_office.building!="")
			{
				lblBuilding.text=_office.building;
				lblBuilding.visible=true;
			}
			else
			{
				lblBuilding.visible=false;
			}
			
			if (_office.address.premise!="")
				_str+=_office.address.premise + "\n";
			if (_office.address.thoroughfare!="")
				_str+=_office.address.thoroughfare + "\n";
			_str+=_office.address.locality + ", " + _office.address.administrative_area + " " + _office.address.postal_code;
			
			lblAddress.text=_str;
			
			lblPhone2.text=_office.phone;
			lblFax.text="Fax: " + _office.fax;
			lblTTY.text="TTY: " + _office.tty;
		} 
		
		/**
		 * @private
		 * 
		 * Override this method to create children for your item renderer 
		 */	
		override protected function createChildren():void
		{
			//super.createChildren();
			// create any additional children for your item renderer here
			lblTitle=new Label();
			lblTitle.styleName="OfficeLabel";
			
			lblBuilding=new Label();
			lblBuilding.styleName="NormalLabel";
			
			
			lblAddress=new Label();
			lblAddress.styleName="ClickLabel";
			
			lblPhone1=new Label();
			lblPhone1.text="Phone: ";
			lblPhone1.styleName="NormalLabel";
			
			lblPhone2=new Label();
			lblPhone2.styleName="ClickLabel";
			
			lblFax=new Label();
			lblTTY=new Label();
			lblFax.styleName="NormalLabel";
			lblTTY.styleName="NormalLabel";
			
			
			addChild(lblTitle);
			addChild(lblBuilding);
			addChild(lblAddress);
			addChild(lblPhone1);
			addChild(lblPhone2);
			addChild(lblFax);
			addChild(lblTTY);
			
			lblPhone2.addEventListener("click", CallPhone);
			lblAddress.addEventListener("click", GetAddress);
		}
		
		private function CallPhone(evt:MouseEvent):void{
			var targetURL:URLRequest = new URLRequest("tel:" + evt.target.text);
			navigateToURL(targetURL);
		}
		
		private function GetAddress(evt:MouseEvent):void{
			var targetURL:URLRequest = new URLRequest("http://maps.google.com/maps?q=" + encodeURIComponent(evt.target.text.replace("\n",",")));
			navigateToURL(targetURL);
		}
		
		/**
		 * @private
		 * 
		 * Override this method to change how the item renderer 
		 * sizes itself. For performance reasons, do not call 
		 * super.measure() unless you need to.
		 */ 
		override protected function measure():void
		{
			super.measure();
			// measure all the subcomponents here and set measuredWidth, measuredHeight, 
			// measuredMinWidth, and measuredMinHeight      
			var verticalPadding:Number = getStyle("paddingTop") + getStyle("paddingBottom");
			measuredHeight = verticalPadding; 
			measuredHeight += getElementPreferredHeight(lblTitle)+_line_padding;
			if (lblBuilding.visible)
				measuredHeight += getElementPreferredHeight(lblBuilding)+_line_padding;
			measuredHeight += getElementPreferredHeight(lblAddress)+_line_padding;
			measuredHeight += getElementPreferredHeight(lblPhone1)+_line_padding;
			measuredHeight += getElementPreferredHeight(lblFax)+_line_padding;
			measuredHeight += getElementPreferredHeight(lblTTY)+_line_padding;
			
			lblTitle.width=getElementPreferredWidth(lblTitle);
			lblTitle.height=getElementPreferredHeight(lblTitle);
			
			lblBuilding.width=getElementPreferredWidth(lblBuilding);
			lblBuilding.height=getElementPreferredHeight(lblBuilding);
			
			lblAddress.width=getElementPreferredWidth(lblAddress);
			lblAddress.height=getElementPreferredHeight(lblAddress);
			
			lblPhone1.width=getElementPreferredWidth(lblPhone1);
			lblPhone1.height=getElementPreferredHeight(lblPhone1);
			
			lblPhone2.width=getElementPreferredWidth(lblPhone2);
			lblPhone2.height=getElementPreferredHeight(lblPhone2);
			
			lblFax.width=getElementPreferredWidth(lblFax);
			lblFax.height=getElementPreferredHeight(lblFax);
			
			lblTTY.width=getElementPreferredWidth(lblTTY);
			lblTTY.height=getElementPreferredHeight(lblTTY);
			//measuredWidth=getElementPreferredWidth(lblTitle);
		}
		
		/**
		 * @private
		 * 
		 * Override this method to change how the background is drawn for 
		 * item renderer.  For performance reasons, do not call 
		 * super.drawBackground() if you do not need to.
		 */
		override protected function drawBackground(unscaledWidth:Number, 
												   unscaledHeight:Number):void
		{
			super.drawBackground(unscaledWidth, unscaledHeight);
			// do any drawing for the background of the item renderer here  
			
			
		}
		
		/**
		 * @private
		 *  
		 * Override this method to change how the background is drawn for this 
		 * item renderer. For performance reasons, do not call 
		 * super.layoutContents() if you do not need to.
		 */
		override protected function layoutContents(unscaledWidth:Number, 
												   unscaledHeight:Number):void
		{
			super.layoutContents(unscaledWidth, unscaledHeight);
			// layout all the subcomponents here  
			
			var PaddingLeft:Number = getStyle("paddingLeft");
			var PaddingRight:Number = getStyle("paddingRight");
			var PaddingTop:Number = getStyle("paddingTop");
			var PaddingBottom:Number = getStyle("paddingBottom");
			
			var _position:Number=PaddingTop;
			lblTitle.x=PaddingLeft;
			lblTitle.y=_position;
			_position+=getElementPreferredHeight(lblTitle)+_line_padding;
			if (lblBuilding.visible)
			{
				lblBuilding.x=PaddingLeft;
				lblBuilding.y=_position;
				_position+=getElementPreferredHeight(lblBuilding)+_line_padding;			
			}
			
			lblAddress.x=PaddingLeft;
			lblAddress.y=_position;
			_position+=getElementPreferredHeight(lblAddress)+_line_padding;
			
			lblPhone1.x=PaddingLeft;
			lblPhone1.y=_position;
			lblPhone2.x=PaddingLeft+ getElementPreferredWidth(lblPhone1)+10;
			lblPhone2.y=_position;
			_position+=getElementPreferredHeight(lblPhone1)+_line_padding;
			
			lblFax.x=PaddingLeft;
			lblFax.y=_position;
			_position+=getElementPreferredHeight(lblFax)+_line_padding;
			
			lblTTY.x=PaddingLeft;
			lblTTY.y=_position;
		}
		
	}
}