package gov.nlrb.mobile
{
	import flash.events.Event;
	
	
	import spark.components.TextArea;
	import spark.components.supportClasses.StyleableTextField;
	import spark.skins.mobile.TextAreaSkin;
	
	
	public class TextAreaFix extends TextArea
	{
		
		
		private var htmlTextChanged:Boolean;
		private var _htmlText:String;
		
		
		override public function set text(value:String):void
		{
			super.text = value;
		}
		
		
		public function set htmlText(value:String):void
		{
			_htmlText = value;
			htmlTextChanged = true;
			invalidateProperties();
		}
		
		
		public function get htmlText():String
		{
			return _htmlText;
		}
		
		
		public function TextAreaFix()
		{
			super();
			setStyle("skinClass", Class(TextAreaSkin));
			addEventListener(Event.ADDED_TO_STAGE, handleAddedToStage);
		}
		
		
		private function handleAddedToStage(event:Event):void
		{
			callLater(resetHtmlText);
		}
		
		
		private function resetHtmlText():void
		{
			htmlTextChanged = true;
			invalidateProperties();
		}
		
		
		override protected function commitProperties():void
		{
			super.commitProperties();
			if(htmlTextChanged && textDisplay)
			{
				StyleableTextField(textDisplay).htmlText = htmlText;
				StyleableTextField(textDisplay).commitStyles();
				htmlTextChanged = false;
				invalidateDisplayList();
			}
		}
		
		
		override protected function updateDisplayList(unscaledWidth:Number, unscaledHeight:Number):void
		{
			super.updateDisplayList(unscaledWidth, unscaledHeight);
		}
		
		
	}
}